DEFINT A-Z

'basic code
DECLARE FUNCTION Bin2Hex% (Binary$)
DECLARE FUNCTION CharacterSelection% (CCN)
DECLARE FUNCTION ExtractBit% (BitLine%, BitCol%)
DECLARE FUNCTION Monitor% (VSSegment)
DECLARE FUNCTION Reverse$ (StringVar$)
DECLARE SUB BlankVidRam (VRSEG)
DECLARE SUB Delay (Period!)
DECLARE SUB DrawMainScreen (FGH)
DECLARE SUB EditCharMatrix (CharNum)
DECLARE SUB Editor (Text$, LeftCol, RightCol, KeyCode)
DECLARE SUB GetFontAddresses (Adapter)
DECLARE SUB LoadFont ()
DECLARE SUB LoadFontCharacter (BeginChar, EndChar, Font$)
DECLARE SUB ParseCmdLine (cmd$, Params$(), Found%)
DECLARE SUB PlotChar (CharNum)
DECLARE SUB PrintAt (Strg$, row, Col, Fg, Bg)
DECLARE SUB PutFontIntoString (FoNTYPE%)
DECLARE SUB SaveFont ()

TYPE RegType
  AX    AS INTEGER
  BX    AS INTEGER
  CX    AS INTEGER
  DX    AS INTEGER
  BP    AS INTEGER
  SI    AS INTEGER
  DI    AS INTEGER
  Flags AS INTEGER
  DS    AS INTEGER
  ES    AS INTEGER
END TYPE

CONST TRUE = -1, FALSE = 0, Version$ = "Andrew's DOS Font Editor  Version .9900"
DIM SHARED Registers AS RegType, Mon
DIM SHARED FontSeg, FontOffset, CgaFont$, EgaFont$, VgaFont$, CGAChar$(256), EGAChar$(256), VGAChar$(256)
DIM SHARED BinPat$(255), FontGridHeight, PatternNum, CharByte$(15), Filename$
DIM SHARED RomFont, ErrorStatus, BRLimiter  ' TempChar$, TempChar2$
DIM SHARED FV$(0 TO 15)
DIM Params$(1 TO 10)

CLEAR , , 2048

SCREEN 0: WIDTH 80, 25: VIEW PRINT 1 TO 25: CLS 'reinit screen

Mon = Monitor%(VSeg)
BlankVidRam VSeg
SELECT CASE Mon
  CASE IS = 5: PRINT "Vga Detected.": FontGridHeight = 15 '0 to 15 Sixteen Scan lines
               PRINT "Please Wait"
               'VgaFont$ = SPACE$(4096)
               GetFontAddresses 1
               PutFontIntoString 1
'               PRINT HEX$(FontSeg), HEX$(FontOffset)
  CASE IS = 4: PRINT "Ega Detected.": FontGridHeight = 13 '0 to 13 Fourteen Scan lines
               PRINT "Please Wait"
               'EgaFont$ = SPACE$(3584)
               GetFontAddresses 0
               PutFontIntoString 0
  CASE ELSE: PRINT "This program Requires VGA or EGA !": END
END SELECT
Delay 2

RESTORE Bits
FOR Bin = 0 TO 255: READ B$: BinPat$(Bin) = B$: NEXT Bin: B$ = ""

' program defaults
  FCGAMODE = FALSE
  FEGAMODE = FALSE
  RetainNonSysFontOnExit = FALSE

ParseCmdLine COMMAND$, Params$(), NumParams%
'IF NumParams% = FALSE THEN Help: Noff = TRUE

FOR I% = 1 TO NumParams%
  q$ = Params$(I%)
  SELECT CASE q$
  CASE "-FCGA", "FCGA": FontGridHeight = 7: FCGAMODE = TRUE: FEGAMODE = FALSE
      VgaFont$ = "": EgaFont$ = ""
      FOR ZZZ = 0 TO 255: VGAChar$(ZZZ) = "": EGAChar$(ZZZ) = "": NEXT ZZZ
      StkOPT& = FRE(-2): StrngOPT& = FRE("")
      CLS : PRINT "Cga font editing mode enabled ! - Forcing Cga font mode !"
      PRINT "Please Wait"
      OUT &H3D4, 9: OUT &H3D5, 7  'Fourteen Scan lines
      'OUT &H3D4, 18: OUT &H3D5, 0   'Clip Bottom Part of Screen
      Registers.AX = &H1102
      Registers.BX = 0
      CALL INTERRUPTX(&H10, Registers, Registers)
      PutFontIntoString 2
      IF RetainNonSysFontOnExit = FALSE THEN Delay 1.5
  CASE "-FEGA", "FEGA": FontGridHeight = 13: FEGAMODE = TRUE: FCGAMODE = FALSE
      VgaFont$ = "": EgaFont$ = ""
      FOR ZZZ = 0 TO 255: VGAChar$(ZZZ) = "": EGAChar$(ZZZ) = "": NEXT ZZZ
      StkOPT& = FRE(-2): StrngOPT& = FRE("")
      CLS : PRINT "Forcing Ega font mode !"
      OUT &H3D4, 9: OUT &H3D5, 13 'Fourteen Scan lines
      OUT &H3D4, 18: OUT &H3D5, 93 'Clip Bottom Part of Screen
      Registers.AX = &H1101
      Registers.BX = 0
      CALL INTERRUPTX(&H10, Registers, Registers)
      PRINT "Please Wait"
      'EgaFont$ = SPACE$(3584)
      GetFontAddresses 0
      PutFontIntoString 0
  CASE "-KEEP", "KEEP"
      PRINT : PRINT "Keeping any font buffer changes on exit !": RetainNonSysFontOnExit = TRUE
      Delay 1
END SELECT
NEXT
IF Mon = 4 THEN FEGAMODE = FALSE 'prevent screw up

CLS
SELECT CASE FontGridHeight 'Establish Grid limit - Box Row Limiter
CASE IS = 7: BRLimiter = 12  'cga
CASE IS = 13: BRLimiter = 18 'ega
CASE IS = 15: BRLimiter = 20 'vga
END SELECT
DrawMainScreen FontGridHeight
ASCIICharacterInBox = 0: GOSUB DisplayCharacterStatistics
LOCATE 1, 1: PRINT Version$;
Delay 1.9
LOCATE 1, 1: PRINT STRING$(80, 32);

DO
   Key$ = UCASE$(INKEY$)
   SELECT CASE Key$
     CASE IS = CHR$(43), IS = CHR$(61) 'Cycle Foward through characters
         ASCIICharacterInBox = ASCIICharacterInBox + 1
         IF ASCIICharacterInBox >= 255 THEN ASCIICharacterInBox = 255
         GOSUB DisplayCharacterStatistics
     CASE IS = CHR$(45) 'Cycle Backward through characters
         ASCIICharacterInBox = ASCIICharacterInBox - 1
         IF ASCIICharacterInBox <= 0 THEN ASCIICharacterInBox = 0
         GOSUB DisplayCharacterStatistics
     CASE IS = CHR$(0) + CHR$(59) 'F1 - Load Font
         LoadFont
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
     CASE IS = CHR$(0) + CHR$(84) 'Shift F1 - DosShell
          IF FCGAMODE = TRUE OR FEGAMODE = TRUE THEN  'return to normal 25 line mode
          IF Mon = 5 THEN
             OUT &H3D4, 9: OUT &H3D5, 15  'Sixteen Scan lines
          ELSE
             OUT &H3D4, 9: OUT &H3D5, 13  'Fourteen Scan lines
          END IF
          OUT &H3D4, 18: OUT &H3D5, 143 'Restore Bottom Part of Screen
          IF Mon = 5 THEN
             Registers.AX = &H1104
             Registers.BX = 0
          ELSE
             Registers.AX = &H1101
             Registers.BX = 0
          END IF
          CALL INTERRUPTX(&H10, Registers, Registers)
          END IF
         CLS : LOCATE 1, 1: PRINT "Type 'Exit' to return to "; Version$;
         SHELL
         COLOR 0, 7: LOCATE 25, 55: PRINT "Press any key to continue."; : COLOR 7, 0
         WHILE INKEY$ = "": WEND: CLS
         IF FCGAMODE = TRUE THEN 'return to cga emulation
         OUT &H3D4, 9: OUT &H3D5, 7  'Fourteen Scan lines
         'OUT &H3D4, 18: OUT &H3D5, 93  'Clip Bottom Part of Screen
         Registers.AX = &H1102
         Registers.BX = 0
         CALL INTERRUPTX(&H10, Registers, Registers)
         END IF
         IF FEGAMODE = TRUE THEN 'return to ega emulation
         OUT &H3D4, 9: OUT &H3D5, 13 'Fourteen Scan lines
         OUT &H3D4, 18: OUT &H3D5, 93 'Clip Bottom Part of Screen
         Registers.AX = &H1101
         Registers.BX = 0
         CALL INTERRUPTX(&H10, Registers, Registers)
         END IF
         BlankVidRam VSeg
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
         LOCATE 24, 2: PRINT UCASE$(Filename$);
     CASE IS = CHR$(0) + CHR$(60) 'F2 - Edit Current Character in Matrix
         EditCharMatrix ASCIICharacterInBox
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
     CASE IS = CHR$(0) + CHR$(61) 'F3 - Save Font
         SaveFont
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
     CASE IS = CHR$(0) + CHR$(62) 'F4 - Preview Current Character
         COLOR 15, 0: LOCATE 6, 55: PRINT "F4. View Single Character";
         TBin$ = ""
         FOR AssimRow = 5 TO BRLimiter
            FOR AssimCol = 6 TO 20 STEP 2
               IF SCREEN(AssimRow, AssimCol, 0) = 219 AND SCREEN(AssimRow, AssimCol + 1, 0) = 219 THEN
                   TBin$ = TBin$ + "1"
               ELSE
                   TBin$ = TBin$ + "0"
               END IF
            NEXT AssimCol
               AsciiNum = Bin2Hex%(TBin$)
               CharByte$(AssimRow - 5) = CHR$(AsciiNum)
               TBin$ = ""
         NEXT AssimRow
         FOR ZZ = 1 TO FontGridHeight + 1: TempChar2$ = TempChar2$ + CharByte$(ZZ - 1): NEXT ZZ
         LoadFontCharacter ASCIICharacterInBox, ASCIICharacterInBox + 1, TempChar2$
         LOCATE 1, 1: PRINT "Waiting 5 Seconds.....";
         PrintAt CHR$(ASCIICharacterInBox), 5, 39, 15, 0 'Print Preview Character
         Delay 5
         COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
         SELECT CASE FontGridHeight
          CASE IS = 7
           LoadFontCharacter 0, 256, CgaFont$
          CASE IS = 13
           LoadFontCharacter 0, 256, EgaFont$
          CASE IS = 15
           LoadFontCharacter 0, 256, VgaFont$
         END SELECT
         PrintAt CHR$(ASCIICharacterInBox), 5, 39, 7, 0 'Print normally
         TempChar2$ = "": FOR CLR = 0 TO 7: CharByte$(CLR) = "": NEXT CLR
         COLOR 7, 0: LOCATE 6, 55: PRINT "F4. View Single Character";
     CASE IS = CHR$(0) + CHR$(63) 'F5 - Select Character
         COLOR 15, 0: LOCATE 7, 55: PRINT "F5. Select Character"; : COLOR 7, 0
         NewCharacter = CharacterSelection%(ASCIICharacterInBox)
         ASCIICharacterInBox = NewCharacter: CLS
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
         LOCATE 24, 2: PRINT UCASE$(Filename$);
     CASE IS = CHR$(0) + CHR$(64) 'F6 - Copy Character
         COLOR 15, 0: LOCATE 8, 55: PRINT "F6. Copy Character": COLOR 7, 0
         CopyChar$ = ""
         SELECT CASE FontGridHeight
         CASE IS = 7: CopyChar$ = CGAChar$(ASCIICharacterInBox): Copied = ASCIICharacterInBox
         CASE IS = 13: CopyChar$ = EGAChar$(ASCIICharacterInBox): Copied = ASCIICharacterInBox
         CASE IS = 15: CopyChar$ = VGAChar$(ASCIICharacterInBox): Copied = ASCIICharacterInBox
         END SELECT
         PrintAt "Character" + STR$(ASCIICharacterInBox) + " (" + CHR$(ASCIICharacterInBox) + ")" + " is in the PASTE buffer !", 1, 1, 143, 0
         Delay 1.5
         COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
         LOCATE 24, 2: PRINT UCASE$(Filename$);
     CASE IS = CHR$(0) + CHR$(65) 'F7 - Paste Character
         COLOR 15, 0: LOCATE 9, 55: PRINT "F7. Paste Character ": COLOR 7, 0
         IF CopyChar$ = "" THEN
            COLOR 31, 0: LOCATE 1, 1: PRINT "You have no character is the PASTE BUFFER !"; : COLOR 7, 0
            Delay 1.5
            GOTO AvoidQuery
         END IF
         LOCATE 1, 1: PRINT "Do you want to paste over the current character ?";
         LOCATE 1, 51
         DO
          Query$ = UCASE$(INKEY$)
          SELECT CASE Query$
           CASE IS = "Y"
             Query = TRUE: PRINT "Yes."; : EXIT DO
           CASE IS = "N"
             Query = FALSE: PRINT "No."; : EXIT DO
          END SELECT
         LOOP
         Delay 1.5
         SELECT CASE Query
           CASE IS = TRUE
              SELECT CASE FontGridHeight
              CASE IS = 7: CGAChar$(ASCIICharacterInBox) = CopyChar$
              CASE IS = 13: EGAChar$(ASCIICharacterInBox) = CopyChar$
              CASE IS = 15: VGAChar$(ASCIICharacterInBox) = CopyChar$
              END SELECT
              PrintAt "Character" + STR$(VAL(CopyChar$)) + " (" + CHR$(Copied) + ")" + " has been PASTED over CURRENT Character !", 1, 1, 143, 0
           CASE IS = FALSE
              PrintAt "Character" + STR$(VAL(CopyChar$)) + " (" + CHR$(Copied) + ")" + " has NOT been PASTED over CURRENT Character !", 1, 1, 143, 0
         END SELECT
         Delay 1.5
AvoidQuery:
         COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
         LOCATE 24, 2: PRINT UCASE$(Filename$);
     CASE IS = CHR$(0) + CHR$(66) 'F8 - Show User the Character set.
         COLOR 15, 0: LOCATE 10, 55: PRINT "F8. Preview Character Set": COLOR 7, 0
         Delay 1
         SELECT CASE FontGridHeight
         CASE IS = 7
          FOR ConCan = 0 TO 255: TFont$ = TFont$ + CGAChar$(ConCan): NEXT ConCan
         CASE IS = 13
          FOR ConCan = 0 TO 255: TFont$ = TFont$ + EGAChar$(ConCan): NEXT ConCan
         CASE IS = 15
          FOR ConCan = 0 TO 255: TFont$ = TFont$ + VGAChar$(ConCan): NEXT ConCan
         END SELECT
         CLS
         LoadFontCharacter 0, 256, TFont$
         TFont$ = ""
         LOCATE 1, 27: PRINT "Preview of Entire Chracter Set"
         FOR PVR = 3 TO 23 STEP 2
         FOR PVC = 18 TO 64 STEP 2
            PrintAt CHR$(ABC), PVR, PVC, 7, 0 'Print normally
            ABC = ABC + 1
            IF ABC = 256 THEN EXIT FOR 'bail out of loops
         NEXT PVC
         NEXT PVR: ABC = 0
         LOCATE 25, 29: PRINT "Press Any key to continue.";
         WHILE INKEY$ = "": WEND: CLS
         SELECT CASE FontGridHeight
          CASE IS = 7
           LoadFontCharacter 0, 256, CgaFont$
          CASE IS = 13
           LoadFontCharacter 0, 256, EgaFont$
          CASE IS = 15
           LoadFontCharacter 0, 256, VgaFont$
         END SELECT
         DrawMainScreen FontGridHeight 'Restore Screen
         GOSUB DisplayCharacterStatistics
         LOCATE 24, 2: PRINT UCASE$(Filename$);
     CASE IS = CHR$(0) + CHR$(67) 'F9 - Video Info
          COLOR 15, 0: LOCATE 11, 55: PRINT "F9. Video Info"; : COLOR 7, 0
          LOCATE 1, 1
          SELECT CASE FontGridHeight
          CASE IS = 7: PRINT "CGA is Emulated,";
          CASE IS = 13: PRINT "EGA is Detected,";
          CASE IS = 15: PRINT "VGA is Detected,";
          END SELECT
          PRINT " Font Address is: "; HEX$(FontSeg); ":"; HEX$(FontOffset);
          IF RomFont = TRUE THEN PRINT " - in video ROM.";  ELSE PRINT " - in allocated RAM.";
          Delay 3: LOCATE 1, 1: PRINT STRING$(80, 32);
          LOCATE 11, 55: PRINT "F9. Video Info";
     CASE IS = CHR$(0) + CHR$(68) 'F10 - Quit
          COLOR 15, 0: LOCATE 12, 55: PRINT "F10. Quit";
          Delay .25
          COLOR 7, 0: LOCATE 12, 55: PRINT "F10. Quit";
         
          IF FEGAMODE = TRUE OR FCGAMODE = TRUE AND Mon = 5 THEN
          OUT &H3D4, 9: OUT &H3D5, 15  'Sixteen Scan lines
          OUT &H3D4, 18: OUT &H3D5, 143 'Restore Bottom Part of Screen
          Registers.AX = &H1104
          Registers.BX = 0
          CALL INTERRUPTX(&H10, Registers, Registers)
          END IF
         
          IF FCGAMODE = TRUE AND Mon = 4 THEN
          OUT &H3D4, 9: OUT &H3D5, 13 'Fourteen Scan lines
          OUT &H3D4, 18: OUT &H3D5, 143 'Clip Bottom Part of Screen
          Registers.AX = &H1101
          Registers.BX = 0
          CALL INTERRUPTX(&H10, Registers, Registers)
          END IF


          IF RetainNonSysFontOnExit = TRUE AND FontGridHeight = 15 THEN
             FOR RetainOnExit = 0 TO 255: Vretain$ = Vretain$ + VGAChar$(RetainOnExit): NEXT RetainOnExit
             LoadFontCharacter 0, 256, Vretain$
             Vretain$ = ""
             StkOPT& = FRE(-2): StrngOPT& = FRE("")
          END IF
         
          IF RetainNonSysFontOnExit = TRUE AND FontGridHeight = 13 THEN
             IF FEGAMODE = TRUE THEN
                OUT &H3D4, 9: OUT &H3D5, 13 'Fourteen Scan lines
                OUT &H3D4, 18: OUT &H3D5, 93 'Clip Bottom Part of Screen
                Registers.AX = &H1101
                Registers.BX = 0
                CALL INTERRUPTX(&H10, Registers, Registers)
             END IF
                FOR RetainOnExit = 0 TO 255: Eretain$ = Eretain$ + EGAChar$(RetainOnExit): NEXT RetainOnExit
                LoadFontCharacter 0, 256, Eretain$
                Eretain$ = ""
                StkOPT& = FRE(-2): StrngOPT& = FRE("")
          END IF
         
          IF RetainNonSysFontOnExit = TRUE AND FontGridHeight = 7 THEN
             IF FCGAMODE = TRUE THEN
                OUT &H3D4, 9: OUT &H3D5, 7  'Fourteen Scan lines
                'OUT &H3D4, 18: OUT &H3D5, 0 'Clip Bottom Part of Screen
                Registers.AX = &H1102
                Registers.BX = 0
                CALL INTERRUPTX(&H10, Registers, Registers)
             END IF
                FOR RetainOnExit = 0 TO 255: Cretain$ = Cretain$ + CGAChar$(RetainOnExit): NEXT RetainOnExit
                LoadFontCharacter 0, 256, Cretain$
                Cretain$ = ""
                StkOPT& = FRE(-2): StrngOPT& = FRE("")
          END IF
          EXIT DO
   END SELECT
LOOP
'PlotChar 251
END

DisplayCharacterStatistics:
         PlotChar ASCIICharacterInBox 'Put Char in Big Box
         PrintAt CHR$(ASCIICharacterInBox), 5, 39, 7, 0 'Print normally
         LOCATE 6, 45: PRINT "    "; : LOCATE 7, 46: PRINT "  ";
         LOCATE 6, 45: PRINT ASCIICharacterInBox; 'print Decimal number
         LOCATE 7, 46: PRINT HEX$(ASCIICharacterInBox); 'print Hexadecimal number
RETURN

ErrHandle:
CLOSE
ErrorStatus = TRUE
SELECT CASE ERR
  CASE IS = 5: PatternNum = 0
  CASE IS = 7
   LOCATE 1, 1: PRINT "Program Error: Out of memory"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I used up all of the DGROUP space, Try again."; : END
  CASE IS = 9
   LOCATE 1, 1: PRINT "Program Error: Array Subscript out of range"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Upper limit of allocated space exceeded."; : GOSUB ClearMSGLINE
  CASE IS = 14
   LOCATE 1, 1: PRINT "Program Error: Out of String Space"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I can't fit this into memory, it is partially loaded."; : GOSUB ClearMSGLINE
  CASE IS = 24
   LOCATE 1, 1: PRINT "Informative Error: Device timeout"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Turn on your printer or activate `on-line' mode."; : GOSUB ClearMSGLINE
  CASE IS = 25
   LOCATE 1, 1: PRINT "Printer Error: Device fault"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I can't talk to your printer or print que."; : GOSUB ClearMSGLINE
  CASE IS = 27
   LOCATE 1, 1: PRINT "Printer Error: Out of paper"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Put Paper in your printer."; : GOSUB ClearMSGLINE
  CASE IS = 52
   LOCATE 1, 1: PRINT "Program or User Error: Bad File Name or number"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "You provided a bad file name or I tried to use a file number that doesn't exist."; : GOSUB ClearMSGLINE
  CASE IS = 53
   LOCATE 1, 1: PRINT "FileManager/User input Error: File not found"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I cannot find the file you requested."; : GOSUB ClearMSGLINE
  CASE IS = 54
   LOCATE 1, 1: PRINT "FileManager/Programmer Error: Bad file mode"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I am unable to read a file properly. Bug fix by programmer required."; : GOSUB ClearMSGLINE
  CASE IS = 55
   LOCATE 1, 1: PRINT "FileManager Error: File already open"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "A file was already opened, all files are now closed."; : GOSUB ClearMSGLINE
  CASE IS = 57
   LOCATE 1, 1: PRINT "System Fault: Device I/O error"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I can not 'talk' to a specific device."; : GOSUB ClearMSGLINE
  CASE IS = 58
   LOCATE 1, 1: PRINT "Informative Error: File already exists"; : GOSUB ClearMSGLINE
  CASE IS = 59
   LOCATE 1, 1: PRINT "FileManager Error: Bad record length"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "A database record of some sort is not long enough or is too long."; : GOSUB ClearMSGLINE
  CASE IS = 61
   LOCATE 1, 1: PRINT "Informative Error: Disk FULL"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Free up some disk space."; : GOSUB ClearMSGLINE
  CASE IS = 62
   LOCATE 1, 1: PRINT "FileManager Error: Input past end of file."; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Attempt to read beyond the end of current file."; : GOSUB ClearMSGLINE
  CASE IS = 63
   LOCATE 1, 1: PRINT "Program Error: Bad record number"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "A database record of some sort doesn't exist."; : GOSUB ClearMSGLINE
  CASE IS = 64
   LOCATE 1, 1: PRINT "User Error: Bad file name"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "You specifically told me to use a file name that is incorrect."; : GOSUB ClearMSGLINE
  CASE IS = 67
   LOCATE 1, 1: PRINT "FileManager Fault: Too many files open"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "I can't handle more files than listed in your CONFIG.SYS file."; : GOSUB ClearMSGLINE
  CASE IS = 68
   LOCATE 1, 1: PRINT "System Error: Device UNAVAILABLE"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "A user serviceable device is not accessable to the computer."; : GOSUB ClearMSGLINE
  CASE IS = 71
   LOCATE 1, 1: PRINT "User or System Error: Disk not Ready"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "Insert a diskette in the current drive. (Excepting Hardrives)"; : GOSUB ClearMSGLINE
  CASE IS = 72
   LOCATE 1, 1: PRINT "Serious Informative Error: Disk-Media error"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "The recordable media surface of the current disk has developed a defect."; : GOSUB ClearMSGLINE
  CASE IS = 73
   LOCATE 1, 1: PRINT "Informative Error: Feature unavailable"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "An advanced capability is not available within this computer."; : GOSUB ClearMSGLINE
  CASE IS = 75
  LOCATE 1, 1: PRINT "FileManager/User input Error: Path/File access error"; : GOSUB ClearMSGLINE
  CASE IS = 76
   LOCATE 1, 1: PRINT "FileManager/User input Error: Path not found"; : GOSUB ClearMSGLINE
   LOCATE 1, 1: PRINT "The path to a file is non-existant."; : GOSUB ClearMSGLINE
  CASE ELSE
   LOCATE 1, 1: PRINT "Bug squashing Required. Contact orginal programmer."; : Delay 3: END
END SELECT
RESUME NEXT

ClearMSGLINE:
Delay 1
LOCATE 1, 1: PRINT STRING$(80, 32);
RETURN

Bits:
'     1
'     2631
'     84268421
DATA "00000000": '0
DATA "00000001": '1
DATA "00000010": '2
DATA "00000011": '3
DATA "00000100": '4
DATA "00000101": '5
DATA "00000110": '6
DATA "00000111": '7
DATA "00001000": '8
DATA "00001001": '9
DATA "00001010": '10
DATA "00001011": '11
DATA "00001100": '12
DATA "00001101": '13
DATA "00001110": '14
DATA "00001111": '15
DATA "00010000": '16
DATA "00010001": '17
DATA "00010010": '18
DATA "00010011": '19
DATA "00010100": '20
DATA "00010101": '21
DATA "00010110": '22
DATA "00010111": '23
DATA "00011000": '24
DATA "00011001": '25
DATA "00011010": '26
DATA "00011011": '27
DATA "00011100": '28
DATA "00011101": '29
DATA "00011110": '30
DATA "00011111": '31
DATA "00100000": '32
DATA "00100001": '33
DATA "00100010": '34
DATA "00100011": '35
DATA "00100100": '36
DATA "00100101": '37
DATA "00100110": '38
DATA "00100111": '39
DATA "00101000": '40
DATA "00101001": '41
DATA "00101010": '42
DATA "00101011": '43
DATA "00101100": '44
DATA "00101101": '45
DATA "00101110": '46
DATA "00101111": '47
DATA "00110000": '48
DATA "00110001": '49
DATA "00110010": '50
DATA "00110011": '51
DATA "00110100": '52
DATA "00110101": '53
DATA "00110110": '54
DATA "00110111": '55
DATA "00111000": '56
DATA "00111001": '57
DATA "00111010": '58
DATA "00111011": '59
DATA "00111100": '60
DATA "00111101": '61
DATA "00111110": '62
DATA "00111111": '63
DATA "01000000": '64
DATA "01000001": '65
DATA "01000010": '66
DATA "01000011": '67
DATA "01000100": '68
DATA "01000101": '69
DATA "01000110": '70
DATA "01000111": '71
DATA "01001000": '72
DATA "01001001": '73
DATA "01001010": '74
DATA "01001011": '75
DATA "01001100": '76
DATA "01001101": '77
DATA "01001110": '78
DATA "01001111": '79
DATA "01010000": '80
DATA "01010001": '81
DATA "01010010": '82
DATA "01010011": '83
DATA "01010100": '84
DATA "01010101": '85
DATA "01010110": '86
DATA "01010111": '87
DATA "01011000": '88
DATA "01011001": '89
DATA "01011010": '90
DATA "01011011": '91
DATA "01011100": '92
DATA "01011101": '93
DATA "01011110": '94
DATA "01011111": '95
DATA "01100000": '96
DATA "01100001": '97
DATA "01100010": '98
DATA "01100011": '99
DATA "01100100": '100
DATA "01100101": '101
DATA "01100110": '102
DATA "01100111": '103
DATA "01101000": '104
DATA "01101001": '105
DATA "01101010": '106
DATA "01101011": '107
DATA "01101100": '108
DATA "01101101": '109
DATA "01101110": '110
DATA "01101111": '111
DATA "01110000": '112
DATA "01110001": '113
DATA "01110010": '114
DATA "01110011": '115
DATA "01110100": '116
DATA "01110101": '117
DATA "01110110": '118
DATA "01110111": '119
DATA "01111000": '120
DATA "01111001": '121
DATA "01111010": '122
DATA "01111011": '123
DATA "01111100": '124
DATA "01111101": '125
DATA "01111110": '126
DATA "01111111": '127
DATA "10000000": '128
DATA "10000001": '129
DATA "10000010": '130
DATA "10000011": '131
DATA "10000100": '132
DATA "10000101": '133
DATA "10000110": '134
DATA "10000111": '135
DATA "10001000": '136
DATA "10001001": '137
DATA "10001010": '138
DATA "10001011": '139
DATA "10001100": '140
DATA "10001101": '141
DATA "10001110": '142
DATA "10001111": '143
DATA "10010000": '144
DATA "10010001": '145
DATA "10010010": '146
DATA "10010011": '147
DATA "10010100": '148
DATA "10010101": '149
DATA "10010110": '150
DATA "10010111": '151
DATA "10011000": '152
DATA "10011001": '153
DATA "10011010": '154
DATA "10011011": '155
DATA "10011100": '156
DATA "10011101": '157
DATA "10011110": '158
DATA "10011111": '159
DATA "10100000": '160
DATA "10100001": '161
DATA "10100010": '162
DATA "10100011": '163
DATA "10100100": '164
DATA "10100101": '165
DATA "10100110": '166
DATA "10100111": '167
DATA "10101000": '168
DATA "10101001": '169
DATA "10101010": '170
DATA "10101011": '171
DATA "10101100": '172
DATA "10101101": '173
DATA "10101110": '174
DATA "10101111": '175
DATA "10110000": '176
DATA "10110001": '177
DATA "10110010": '178
DATA "10110011": '179
DATA "10110100": '180
DATA "10110101": '181
DATA "10110110": '182
DATA "10110111": '183
DATA "10111000": '184
DATA "10111001": '185
DATA "10111010": '186
DATA "10111011": '187
DATA "10111100": '188
DATA "10111101": '189
DATA "10111110": '190
DATA "10111111": '191
DATA "11000000": '192
DATA "11000001": '193
DATA "11000010": '194
DATA "11000011": '195
DATA "11000100": '196
DATA "11000101": '197
DATA "11000110": '198
DATA "11000111": '199
DATA "11001000": '200
DATA "11001001": '201
DATA "11001010": '202
DATA "11001011": '203
DATA "11001100": '204
DATA "11001101": '205
DATA "11001110": '206
DATA "11001111": '207
DATA "11010000": '208
DATA "11010001": '209
DATA "11010010": '210
DATA "11010011": '211
DATA "11010100": '212
DATA "11010101": '213
DATA "11010110": '214
DATA "11010111": '215
DATA "11011000": '216
DATA "11011001": '217
DATA "11011010": '218
DATA "11011011": '219
DATA "11011100": '220
DATA "11011101": '221
DATA "11011110": '222
DATA "11011111": '223
DATA "11100000": '224
DATA "11100001": '225
DATA "11100010": '226
DATA "11100011": '227
DATA "11100100": '228
DATA "11100101": '229
DATA "11100110": '230
DATA "11100111": '231
DATA "11101000": '232
DATA "11101001": '233
DATA "11101010": '234
DATA "11101011": '235
DATA "11101100": '236
DATA "11101101": '237
DATA "11101110": '238
DATA "11101111": '239
DATA "11110000": '240
DATA "11110001": '241
DATA "11110010": '242
DATA "11110011": '243
DATA "11110100": '244
DATA "11110101": '245
DATA "11110110": '246
DATA "11110111": '247
DATA "11111000": '248
DATA "11111001": '249
DATA "11111010": '250
DATA "11111011": '251
DATA "11111100": '252
DATA "11111101": '253
DATA "11111110": '254
DATA "11111111": '255

FUNCTION Bin2Hex% (Binary$) STATIC
Temp& = 0: Count = 0
FOR X = LEN(Binary$) TO 1 STEP -1
 IF MID$(Binary$, X, 1) = "1" THEN
    Temp& = Temp& + 2 ^ Count
 END IF
    Count = Count + 1
NEXT
IF Temp& > 32767 THEN Temp& = Temp& - 65536
Bin2Hex% = Temp&
END FUNCTION

SUB BlankVidRam (VRSEG)
SELECT CASE HEX$(VRSEG)
CASE IS = "B800": DEF SEG = VRSEG
CASE IS = "B000": DEF SEG = VRSEG
END SELECT
FOR MZ = 0 TO 9999: POKE MZ, 0: NEXT MZ: DEF SEG
END SUB

FUNCTION CharacterSelection% (CCM)
OldChar = CCM
COLOR 0, 7
LOCATE 8, 14: PRINT CHR$(218); STRING$(53, 196); CHR$(191);
LOCATE 9, 14: PRINT " Use the arrow keys to choose the desired character. ";
LOCATE 10, 14: PRINT " Press Enter to  confirm selection,  ESCape  aborts. ";
LOCATE 11, 14: PRINT CHR$(195); STRING$(53, 196); CHR$(180);
FOR DSUW = 12 TO 16: LOCATE DSUW, 14: PRINT CHR$(179); STRING$(53, 32); CHR$(179); : NEXT DSUW
LOCATE 17, 14: PRINT CHR$(192); STRING$(53, 196); CHR$(217);
FOR CharLine1 = 0 TO 52: PrintAt CHR$(CharLine1), 12, 15 + CharLine1, 0, 7: NEXT CharLine1
FOR CharLine2 = 53 TO 105: LOCATE 13, 15 + CharLine2 - 53: PRINT CHR$(CharLine2); : NEXT CharLine2
FOR CharLine3 = 106 TO 158: LOCATE 14, 15 + CharLine3 - 106: PRINT CHR$(CharLine3); : NEXT CharLine3
FOR CharLine4 = 159 TO 211: LOCATE 15, 15 + CharLine4 - 159: PRINT CHR$(CharLine4); : NEXT CharLine4
FOR CharLine5 = 212 TO 255: LOCATE 16, 15 + CharLine5 - 212: PRINT CHR$(CharLine5); : NEXT CharLine5

COLOR 31, 0: HIGH = TRUE: GOSUB Highlight

DO
  SEL$ = INKEY$
  SELECT CASE SEL$
  CASE IS = CHR$(0) + CHR$(72) ' Up
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       CCM = CCM - 53
       IF CCM <= TRUE THEN CCM = 255
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
  CASE IS = CHR$(0) + CHR$(80) ' Down
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       CCM = CCM + 53
       IF CCM >= 256 THEN CCM = 0
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
  CASE IS = CHR$(0) + CHR$(75)' Left
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       CCM = CCM - 1
       IF CCM <= TRUE THEN CCM = 255
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
  CASE IS = CHR$(0) + CHR$(77)' Right
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       CCM = CCM + 1
       IF CCM >= 256 THEN CCM = 0
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
  CASE IS = CHR$(13)' Enter
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
       Delay 1
       COLOR 7, 0
       CharacterSelection% = CCM
       EXIT DO
  CASE IS = CHR$(27)' ESCape
       COLOR 0, 7: HIGH = FALSE: GOSUB Highlight
       CCM = OldChar
       COLOR 31, 0: HIGH = TRUE: GOSUB Highlight
       Delay 1
       CharacterSelection% = OldChar
       COLOR 7, 0
       EXIT DO
  END SELECT
'  LOCATE 1, 1: PRINT CCM
LOOP
EXIT FUNCTION

Highlight:
SELECT CASE CCM
      CASE 0 TO 52
           IF HIGH = TRUE THEN
              PrintAt CHR$(CCM), 12, 15 + CCM, 31, 7
           ELSE
              PrintAt CHR$(CCM), 12, 15 + CCM, 0, 7
           END IF
      CASE 53 TO 105: LOCATE 13, 15 + CCM - 53: PRINT CHR$(CCM);
      CASE 106 TO 158: LOCATE 14, 15 + CCM - 106: PRINT CHR$(CCM);
      CASE 159 TO 211: LOCATE 15, 15 + CCM - 159: PRINT CHR$(CCM);
      CASE 212 TO 255: LOCATE 16, 15 + CCM - 212: PRINT CHR$(CCM);
END SELECT
RETURN
END FUNCTION

SUB Delay (Period!)
   Begin! = TIMER
   DO UNTIL (TIMER - Begin! > Period!) OR (TIMER - Begin! < 0)
   LOOP
END SUB

SUB DrawMainScreen (FGH)
'Begin Draw Box
'draw outer box
LOCATE 2, 1: PRINT CHR$(213) + STRING$(78, 205) + CHR$(184);
FOR BX = 3 TO 24: LOCATE BX, 1: PRINT CHR$(179); : LOCATE BX, 80: PRINT CHR$(179); : NEXT BX
LOCATE 25, 1: PRINT CHR$(212) + STRING$(78, 205) + CHR$(190);
'print Onscreen Text
LOCATE 5, 28: PRINT "Character:"; : LOCATE 6, 24: PRINT "Dec Character number:";
LOCATE 7, 24: PRINT "Hex Character number:";
LOCATE 2, 54: PRINT CHR$(209);
LOCATE 3, 54: PRINT CHR$(179); "F1. Load Font": LOCATE 4, 54: PRINT CHR$(179); "F2. Edit Character in box"
LOCATE 5, 54: PRINT CHR$(179); "F3. Save Font": LOCATE 6, 54: PRINT CHR$(179); "F4. View Single Character"
LOCATE 7, 54: PRINT CHR$(179); "F5. Select Character": LOCATE 8, 54: PRINT CHR$(179); "F6. Copy Character       "
LOCATE 9, 54: PRINT CHR$(179); "F7. Paste Character ": LOCATE 10, 54: PRINT CHR$(179); "F8. Preview Character Set"
LOCATE 11, 54: PRINT CHR$(179); "F9. Video Info": LOCATE 12, 54: PRINT CHR$(179); "F10. Quit"
LOCATE 13, 54: PRINT CHR$(192) + STRING$(25, 196) + CHR$(180)
LOCATE 23, 1: PRINT CHR$(195); STRING$(78, 196); CHR$(180);
' Help
LOCATE 15, 29: PRINT "A little Help:";
'                     ---------------------------------------------
LOCATE 16, 29: PRINT "Press a function key use the functions listed";
LOCATE 17, 29: PRINT "in the box. (Text will become bright-white to";
LOCATE 18, 29: PRINT "indicate a  function is  in use.)  Press  the";
LOCATE 19, 29: PRINT "plus  key to  increment  the ASCII character,";
LOCATE 20, 29: PRINT "minus   decrements  the   current  character.";
LOCATE 21, 29: PRINT "Range is zero to 255.  (Only available now !)";

'draw font matrix box
LOCATE 3, 6: PRINT " 1 2 3 4 5 6 7 8"; : LOCATE 4, 6: PRINT STRING$(16, 220);
VertNum$ = CHR$(32) + CHR$(32)
FOR Box = 0 TO FGH
IF LEN(LTRIM$(STR$(Box + 1))) = 1 THEN 'if the string length = 1 then
   RSET VertNum$ = STR$(Box + 1) 'right justify single digits
ELSE
   VertNum$ = "": VertNum$ = LTRIM$(STR$(Box + 1)) 'trim left space
END IF
LOCATE 5 + Box, 3: PRINT VertNum$;
LOCATE 5 + Box, 5: PRINT CHR$(222) + STRING$(16, 177) + CHR$(221): NEXT Box
LOCATE FGH + 6, 6: PRINT STRING$(16, 223);
'End Draw Box
END SUB

SUB EditCharMatrix (CharNum)
COLOR 15, 0: LOCATE 4, 55: PRINT "F2. Edit Character in box"; : COLOR 7, 0

LOCATE 8, 55: PRINT "F6. Flip Horizontal"; : LOCATE 9, 55: PRINT "F7. Flip Vertical  ";
LOCATE 16, 29: PRINT "Use the arrow keys to move the cursor,  press";
LOCATE 17, 29: PRINT "the spacebar to toggle a bit on or off. Press";
LOCATE 18, 29: PRINT "ESCape  to  *ABORT*   editing   the   current";
LOCATE 19, 29: PRINT "character  in  the  box.  Pressing  Enter <";
LOCATE 20, 29: PRINT "saves   the   new    character   to   memory.";
LOCATE 21, 29: PRINT STRING$(45, 32);

SELECT CASE FontGridHeight
CASE IS = 7: TempChar$ = CGAChar$(CharNum)
CASE IS = 13: TempChar$ = EGAChar$(CharNum)
CASE IS = 15: TempChar$ = VGAChar$(CharNum)
END SELECT

FOR OriginChar = 1 TO FontGridHeight + 1 'Split Character into bytes
    CharByte$(OriginChar - 1) = MID$(TempChar$, OriginChar, 1)
    'LOCATE 4 + OriginChar, 1: PRINT BinPat$(ASC(CharByte$(OriginChar - 1)))
NEXT OriginChar

BoxRow = 5: BoxCol = 6: PenDown = FALSE: Eraser = FALSE
COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
BitTog = ExtractBit%(BoxRow, BoxCol)
'IF FontGridHeight = 15 THEN BRLimiter = 20 ELSE BRLimiter = 18
ON ERROR GOTO ErrHandle
DO
  E$ = UCASE$(INKEY$)
  SELECT CASE E$
  CASE IS = CHR$(0) + CHR$(72) 'up   - Arrow key
       COLOR 7, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
       BoxRow = BoxRow - 1
       IF BoxRow <= 5 THEN BoxRow = 5
       IF PenDown = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       IF Eraser = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
       'TempLine$ = BinPat$(ASC(CharByte$(BoxRow - 5)))
       'PrintAt TempLine$, 1, 1, 7, 0
  CASE IS = CHR$(0) + CHR$(80) 'Down - Arrow key
       COLOR 7, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
       BoxRow = BoxRow + 1
       IF BoxRow >= BRLimiter THEN BoxRow = BRLimiter
       IF PenDown = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       IF Eraser = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
       'TempLine$ = BinPat$(ASC(CharByte$(BoxRow - 5)))
       'PrintAt TempLine$, 1, 1, 7, 0
  CASE IS = CHR$(0) + CHR$(75) 'Left - Arrow key
       COLOR 7, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
       BoxCol = BoxCol - 2
       IF BoxCol <= 6 THEN BoxCol = 6
       IF PenDown = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       IF Eraser = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(0) + CHR$(77) 'Right - Arrow key
       COLOR 7, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
       BoxCol = BoxCol + 2
       IF BoxCol >= 20 THEN BoxCol = 20
       IF PenDown = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       IF Eraser = TRUE THEN LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(32) 'Bit Toggle - SpaceBar
       BitTog = NOT BitTog
       SELECT CASE BoxCol
       CASE IS = 6 '1
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 8 '2
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 10'3
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 12'4
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 14'5
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 16'6
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 18'7
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       CASE IS = 20'8
        IF BitTog = TRUE THEN
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        ELSE
           COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT "";
        END IF
       END SELECT
  CASE IS = CHR$(80) 'Pen Toggle (continous bit plotting) - P
       PenDown = NOT PenDown
       IF PenDown = TRUE THEN
          Eraser = FALSE
          COLOR 31, 0: LOCATE 1, 1: PRINT "Pen Down ! ";
          LOCATE BoxRow, BoxCol: PRINT "";
          GOSUB SetNewBit
       ELSE
          COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
       END IF
  CASE IS = CHR$(69) 'Eraser Toggle (continous bit erasing) - E
       Eraser = NOT Eraser
       IF Eraser = TRUE THEN
          PenDown = FALSE
          COLOR 31, 0: LOCATE 1, 1: PRINT "Eraser On !";
          LOCATE BoxRow, BoxCol: PRINT "";
          GOSUB SetNewBit
       ELSE
          COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
       END IF
  CASE IS = CHR$(13) 'Set Character in Stone - Enter
       TBin$ = ""
       FOR AssimRow = 5 TO BRLimiter
          FOR AssimCol = 6 TO 20 STEP 2
             IF SCREEN(AssimRow, AssimCol, 0) = 219 AND SCREEN(AssimRow, AssimCol + 1, 0) = 219 THEN
                TBin$ = TBin$ + "1"
             ELSE
                TBin$ = TBin$ + "0"
             END IF
          NEXT AssimCol
            AsciiNum = Bin2Hex%(TBin$)
            CharByte$(AssimRow - 5) = CHR$(AsciiNum)
            TBin$ = ""
       NEXT AssimRow
       FOR ZZ = 1 TO FontGridHeight + 1: TempChar2$ = TempChar2$ + CharByte$(ZZ - 1): NEXT
       SELECT CASE FontGridHeight
        CASE IS = 7: CGAChar$(CharNum) = "": CGAChar$(CharNum) = TempChar2$
        CASE IS = 13: EGAChar$(CharNum) = "": EGAChar$(CharNum) = TempChar2$
        CASE IS = 15: VGAChar$(CharNum) = "": VGAChar$(CharNum) = TempChar2$
       END SELECT
       EXIT DO
  CASE IS = CHR$(0) + CHR$(82) 'Insert Blank Line At Cursor Column - Insert
       COLOR 7, 0
       FOR InverRow = BRLimiter TO BoxRow STEP -1
          FOR InverCol = 20 TO 6 STEP -2
             IF SCREEN(InverRow - 1, InverCol, 0) = 219 AND SCREEN(InverRow - 1, InverCol + 1, 0) = 219 THEN
                LOCATE InverRow, InverCol: PRINT "";
             ELSE
                LOCATE InverRow, InverCol: PRINT "";
             END IF
          NEXT InverCol
       NEXT InverRow
       COLOR 7, 0: LOCATE BoxRow, 6: PRINT STRING$(16, 177);
       GOSUB SetNewBit
  CASE IS = CHR$(0) + CHR$(83) 'Delete Line At Cursor Column - Delete
       COLOR 7, 0
       FOR InverRow = BoxRow TO BRLimiter
          FOR InverCol = 6 TO 20 STEP 2
             IF SCREEN(InverRow + 1, InverCol, 0) = 219 AND SCREEN(InverRow + 1, InverCol + 1, 0) = 219 THEN
                LOCATE InverRow, InverCol: PRINT "";
             ELSE
                LOCATE InverRow, InverCol: PRINT "";
             END IF
          NEXT InverCol
       NEXT InverRow
       GOSUB SetNewBit
  CASE IS = CHR$(0) + CHR$(62) 'F4 - Preview Current Character
       COLOR 15, 0: LOCATE 6, 55: PRINT "F4. View Single Character";
       TBin$ = ""
       FOR AssimRow = 5 TO BRLimiter
          FOR AssimCol = 6 TO 20 STEP 2
             IF SCREEN(AssimRow, AssimCol, 0) = 219 AND SCREEN(AssimRow, AssimCol + 1, 0) = 219 THEN
                TBin$ = TBin$ + "1"
             ELSE
                TBin$ = TBin$ + "0"
             END IF
          NEXT AssimCol
            AsciiNum = Bin2Hex%(TBin$)
            CharByte$(AssimRow - 5) = CHR$(AsciiNum)
            TBin$ = ""
       NEXT AssimRow
       FOR ZZ = 1 TO FontGridHeight + 1: TempChar2$ = TempChar2$ + CharByte$(ZZ - 1): NEXT ZZ
       LoadFontCharacter CharNum, CharNum + 1, TempChar2$
       LOCATE 1, 1: PRINT "Waiting 5 Seconds.....";
       PrintAt CHR$(CharNum), 5, 39, 15, 0 'Print Preview Character
       Delay 5
       COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
         SELECT CASE FontGridHeight
          CASE IS = 7
           LoadFontCharacter 0, 256, CgaFont$
          CASE IS = 13
           LoadFontCharacter 0, 256, EgaFont$
          CASE IS = 15
           LoadFontCharacter 0, 256, VgaFont$
         END SELECT
       PrintAt CHR$(CharNum), 5, 39, 7, 0 'Print normally
       TempChar2$ = "": FOR CLR = 0 TO 7: CharByte$(CLR) = "": NEXT CLR
       COLOR 7, 0: LOCATE 6, 55: PRINT "F4. View Single Character";
       GOSUB SetNewBit
  CASE IS = CHR$(44) 'Vertical Column delete at Cursor Row - , / <
       COLOR 7, 0
           FOR InverRow = 5 TO BRLimiter
           LOCATE InverRow, BoxCol: PRINT "";
           NEXT InverRow
       FOR InverCol = BoxCol + 2 TO 20 STEP 2
           FOR InverRow = 5 TO BRLimiter
              IF SCREEN(InverRow, InverCol + 1, 0) = 219 AND SCREEN(InverRow, InverCol + 1, 0) = 219 THEN
                 IF InverCol - 2 = 4 THEN InverCol = 8
                 LOCATE InverRow, InverCol - 2: PRINT "";
              ELSE
                 IF InverCol - 2 = 4 THEN InverCol = 8
                 LOCATE InverRow, InverCol - 2: PRINT "";
              END IF
           LOCATE InverRow, InverCol: PRINT "";
           NEXT InverRow
       NEXT InverCol
       GOSUB SetNewBit
  CASE IS = CHR$(46) 'Vertical Column Insert at Cursor Row - . / >
       COLOR 7, 0
       FOR InverRow = 5 TO BRLimiter
          FOR InverCol = 20 TO BoxCol STEP -2
              IF SCREEN(InverRow, InverCol - 1, 0) = 219 AND SCREEN(InverRow, InverCol - 1, 0) = 219 THEN
                 LOCATE InverRow, InverCol: PRINT "";
              ELSE
                 LOCATE InverRow, InverCol: PRINT "";
              END IF
          NEXT InverCol
          LOCATE InverRow, BoxCol: PRINT "";
       NEXT InverRow
       GOSUB SetNewBit
  CASE IS = CHR$(91) 'Insert Bit & Shift Left on Row (Clip end) - [
       COLOR 7, 0
          FOR InverCol = 8 TO BoxCol STEP 2
              IF SCREEN(BoxRow, InverCol + 1, 0) = 219 AND SCREEN(BoxRow, InverCol + 1, 0) = 219 THEN
                 LOCATE BoxRow, InverCol - 2: PRINT "";
              ELSE
                 LOCATE BoxRow, InverCol - 2: PRINT "";
              END IF
          NEXT InverCol
              LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(93) 'Insert Bit & Shift Right on Row (Clip end) - ]
       COLOR 7, 0
          FOR InverCol = 20 TO BoxCol STEP -2
              IF SCREEN(BoxRow, InverCol - 1, 0) = 219 AND SCREEN(BoxRow, InverCol - 1, 0) = 219 THEN
                 LOCATE BoxRow, InverCol: PRINT "";
              ELSE
                 LOCATE BoxRow, InverCol: PRINT "";
              END IF
          NEXT InverCol
              LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(81) 'Insert Bit & Shift Up on Column (Clip end) - Q
       COLOR 7, 0
          FOR InverRow = 6 TO BoxRow
              IF SCREEN(InverRow, BoxCol, 0) = 219 AND SCREEN(InverRow, BoxCol + 1, 0) = 219 THEN
                 LOCATE InverRow - 1, BoxCol: PRINT "";
              ELSE
                 LOCATE InverRow - 1, BoxCol: PRINT "";
              END IF
          NEXT InverRow
              LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(65) 'Insert Bit & Shift Down on Column (Clip end) - A
       COLOR 7, 0
          FOR InverRow = BRLimiter - 1 TO BoxRow STEP -1
              IF SCREEN(InverRow, BoxCol, 0) = 219 AND SCREEN(InverRow, BoxCol + 1, 0) = 219 THEN
                 LOCATE InverRow + 1, BoxCol: PRINT "";
              ELSE
                 LOCATE InverRow + 1, BoxCol: PRINT "";
              END IF
          NEXT InverRow
              LOCATE BoxRow, BoxCol: PRINT "";
       GOSUB SetNewBit
  CASE IS = CHR$(72) 'Draw Horizontal line- H
       COLOR 7, 0: LOCATE BoxRow, 6: PRINT STRING$(16, 219);
       GOSUB SetNewBit
  CASE IS = CHR$(86)  'Draw Vertical line - V
       COLOR 7, 0
       FOR ZVX = 5 TO BRLimiter: LOCATE ZVX, BoxCol: PRINT ""; : NEXT ZVX
       GOSUB SetNewBit
  CASE IS = CHR$(8) 'Clear Horizontal line- Ctrl-H
       COLOR 7, 0: LOCATE BoxRow, 6: PRINT STRING$(16, 177);
       GOSUB SetNewBit
  CASE IS = CHR$(22) 'Clear Vertical line- Ctrl-V
       COLOR 7, 0
       FOR ZVX = 5 TO BRLimiter: LOCATE ZVX, BoxCol: PRINT ""; : NEXT ZVX
       GOSUB SetNewBit
  CASE IS = CHR$(73) 'Invert char - I
       COLOR 7, 0
       FOR InverRow = 5 TO BRLimiter
          FOR InverCol = 6 TO 20 STEP 2
             IF SCREEN(InverRow, InverCol, 0) = 219 AND SCREEN(InverRow, InverCol + 1, 0) = 219 THEN
                LOCATE InverRow, InverCol: PRINT "";
             ELSE
                LOCATE InverRow, InverCol: PRINT "";
             END IF
          NEXT InverCol
       NEXT InverRow
       GOSUB SetNewBit
  CASE IS = CHR$(0) + CHR$(64)   'Flip Horizontal - F6
       COLOR 15, 0: LOCATE 8, 55: PRINT "F6. Flip Horizontal": COLOR 7, 0
       FH$ = ""
       FOR AssimRow = 5 TO BRLimiter
          FOR AssimCol = 6 TO 20 STEP 2
             IF SCREEN(AssimRow, AssimCol, 0) = 219 AND SCREEN(AssimRow, AssimCol + 1, 0) = 219 THEN
                FH$ = FH$ + ""
             ELSE
                FH$ = FH$ + ""
             END IF
          NEXT AssimCol
            HRev$ = Reverse$(FH$)
            LOCATE AssimRow, 6: PRINT HRev$;
            FH$ = "": HRev$ = ""
       NEXT AssimRow
       LOCATE 8, 55: PRINT "F6. Flip Horizontal"
       GOSUB SetNewBit
  CASE IS = CHR$(0) + CHR$(65) 'Flip Vertical - F7
       COLOR 15, 0: LOCATE 9, 55: PRINT "F7. Flip Vertical"; : COLOR 7, 0
       FOR ClearFV = 0 TO FontGridHeight: FV$(ClearFV) = "": NEXT ClearFV
       FOR AssimRow = 5 TO BRLimiter
          FOR AssimCol = 6 TO 20 STEP 2
            IF SCREEN(AssimRow, AssimCol, 0) = 219 AND SCREEN(AssimRow, AssimCol + 1, 0) = 219 THEN
               FV$(AssimRow - 5) = FV$(AssimRow - 5) + ""
            ELSE
               FV$(AssimRow - 5) = FV$(AssimRow - 5) + ""
            END IF
          NEXT AssimCol
       NEXT AssimRow
       FOR VFlip = BRLimiter TO 5 STEP -1: LOCATE 5 + (BRLimiter - VFlip), 6: PRINT FV$(VFlip - 5); : NEXT VFlip
       LOCATE 9, 55: PRINT "F7. Flip Vertical";
       GOSUB SetNewBit
  CASE IS = CHR$(27) 'abort ESC
       EXIT DO 'Abort edit
  END SELECT
LOOP
COLOR 7, 0: LOCATE 4, 55: PRINT "F2. Edit Character in box";
'PlotChar CharNum 'Put Char in Big Box
TempChar$ = "": TempChar2$ = "": FOR CLR = 0 TO 7: CharByte$(CLR) = "": NEXT CLR
COLOR 7, 0: LOCATE 1, 1: PRINT STRING$(80, 32);
EXIT SUB

SetNewBit:
       COLOR 31, 0: LOCATE BoxRow, BoxCol: PRINT CHR$(SCREEN(BoxRow, BoxCol)); CHR$(SCREEN(BoxRow, BoxCol + 1))
       BitTog = ExtractBit%(BoxRow, BoxCol)
RETURN
END SUB

SUB Editor (Text$, LeftCol, RightCol, KeyCode)
  '----- Find the cursor's size.
  DEF SEG = 0
  IF PEEK(&H463) = &HB4 THEN
     CsrSize = 12               'mono uses 13 scan lines
  ELSE
     CsrSize = 7                'color uses 8
  END IF

  '----- Work with a temporary copy.
  Edit$ = SPACE$(RightCol - LeftCol + 1)
  LSET Edit$ = Text$

  '----- See where to begin editing and print the string.
  TxtPos = POS(0) - LeftCol + 1
  IF TxtPos < 1 THEN TxtPos = 1
  IF TxtPos > LEN(Edit$) THEN TxtPos = LEN(Edit$)

  LOCATE , LeftCol
  SELECT CASE FontGridHeight
  CASE IS = 7: LOCATE , , , CsrSize - 5, CsrSize
  CASE IS = 13: LOCATE , , , CsrSize - 2, CsrSize
  CASE IS = 15: LOCATE , , , CsrSize - 2, CsrSize
  END SELECT
  PRINT Edit$;

  '----- This is the main loop for handling key presses.
  DO
     LOCATE , LeftCol + TxtPos - 1, 1

     DO
       Ky$ = INKEY$
     LOOP UNTIL LEN(Ky$)        'wait for a keypress

     IF LEN(Ky$) = 1 THEN       'create a key code
       KeyCode = ASC(Ky$)       'regular character key
     ELSE                       'extended key
       KeyCode = -ASC(RIGHT$(Ky$, 1))
     END IF

     '----- Branch according to the key pressed.
     SELECT CASE KeyCode

       '----- Backspace: decrement the pointer and the
       '      cursor, and ignore if in the first column.
       CASE 8
         TxtPos = TxtPos - 1
         LOCATE , LeftCol + TxtPos - 1, 0
         IF TxtPos > 0 THEN
           IF InsStatus THEN
             MID$(Edit$, TxtPos) = MID$(Edit$, TxtPos + 1) + " "
           ELSE
             MID$(Edit$, TxtPos) = " "
           END IF
             PRINT MID$(Edit$, TxtPos);
         END IF

       '----- Enter or Escape: this block is optional in
       '      case you want to handle these separately.
       CASE 13, 27
         EXIT DO                'exit the subprogram

       '----- Letter keys: turn off the cursor to hide
       '      the printing, handle Insert mode as needed.
       CASE 32 TO 254
         LOCATE , , 0
         IF InsStatus THEN      'expand the string
           MID$(Edit$, TxtPos) = Ky$ + MID$(Edit$, TxtPos)
           PRINT MID$(Edit$, TxtPos);
         ELSE                   'else insert character
           MID$(Edit$, TxtPos) = Ky$
           PRINT Ky$;
         END IF
         TxtPos = TxtPos + 1    'update position counter

       '----- Left arrow: decrement the position counter.
       CASE -75
         TxtPos = TxtPos - 1

       '----- Right arrow: increment position counter.
       CASE -77
         TxtPos = TxtPos + 1

       '----- Home: jump to the first character position.
       CASE -71
         TxtPos = 1

       '----- End: search for the last non-blank, and
       '      make that the current editing position.
       CASE -79
         FOR N = LEN(Edit$) TO 1 STEP -1
           IF MID$(Edit$, N, 1) <> " " THEN EXIT FOR
         NEXT
         TxtPos = N + 1
         IF TxtPos > LEN(Edit$) THEN TxtPos = LEN(Edit$)

       '----- Insert key: toggle the Insert state and
       '      adjust the cursor size.
       CASE -82
         InsStatus = NOT InsStatus
         IF InsStatus THEN
           SELECT CASE FontGridHeight
           CASE IS = 7: LOCATE , , , CsrSize - 5, CsrSize
           CASE IS = 13: LOCATE , , , CsrSize \ 2, CsrSize
           CASE IS = 15: LOCATE , , , CsrSize \ 2, CsrSize
           END SELECT
         ELSE
           SELECT CASE FontGridHeight
           CASE IS = 7: LOCATE , , , CsrSize - 7, CsrSize
           CASE IS = 13: LOCATE , , , CsrSize - 2, CsrSize
           CASE IS = 15: LOCATE , , , CsrSize - 2, CsrSize
           END SELECT
         END IF

       '----- Delete: delete the current character and
       '      reprint what remains in the string.
       CASE -83
         MID$(Edit$, TxtPos) = MID$(Edit$, TxtPos + 1) + " "
         LOCATE , , 0
         PRINT MID$(Edit$, TxtPos);

       '---- All other keys: exit the subprogram
       CASE ELSE
         EXIT DO
     END SELECT

  '----- Loop until the cursor moves out of the field.
  LOOP UNTIL TxtPos < 1 OR TxtPos > LEN(Edit$)

  Text$ = RTRIM$(Edit$)         'trim the text
END SUB

FUNCTION ExtractBit% (BitLine, BitCol)
 IF SCREEN(BitLine, BitCol, 0) = 219 AND SCREEN(BitLine, BitCol + 1, 0) = 219 THEN
    ExtractBit% = TRUE 'Set to True to make sure Bit Toggle Works
 ELSE
    ExtractBit% = FALSE
 END IF
END FUNCTION

SUB GetFontAddresses (Adapter)
'INT 10 - VIDEO - GET FONT INFORMATION (EGA, MCGA, VGA)
'        AX = 1130h
'        BH = pointer specifier
'            00h INT 1Fh pointer
'            01h INT 43h pointer
'            02h ROM 8x14 character font pointer
'            03h ROM 8x8 double dot font pointer
'            04h ROM 8x8 double dot font (high 128 characters)
'            05h ROM alpha alternate (9 by 14) pointer (EGA,VGA)
'            06h ROM 8x16 font (MCGA, VGA)
'            07h ROM alternate 9x16 font (VGA only) (see #0020)
'            11h (UltraVision v2+) 8x20 font (VGA) or 8x19 font (autosync EGA)
'            12h (UltraVision v2+) 8x10 font (VGA) or 8x11 font (autosync EGA)
'Return: ES:BP = specified pointer
'        CX    = bytes/character of on-screen font (not the requested font!)
'        DL    = highest character row on screen
'Note:   for UltraVision v2+, the 9xN alternate fonts follow the corresponding
'          8xN font at ES:BP+256N
'BUG:    the IBM EGA and some other EGA cards return in DL the number of rows on
'          screen rather than the highest row number (which is one less).
'SeeAlso: AX=1100h,AX=1120h,INT 1F,INT 43
RomFont = TRUE
Registers.AX = &H1130 'GET FONT INFORMATION

SELECT CASE Adapter
  CASE IS = 0'Ega
    Registers.BX = &H200  'Get 8x14 address (EGA,VGA)
  CASE IS = 1 'VGA
    Registers.BX = &H600  'Get 8x16 address (EGA,VGA)
  CASE ELSE: PRINT "Invalid Information request !": END
END SELECT
CALL INTERRUPTX(&H10, Registers, Registers)
FontSeg = Registers.ES: FontOffset = Registers.BP
END SUB

SUB LoadFont
COLOR 15, 0: LOCATE 3, 55: PRINT "F1. Load Font"; : COLOR 7, 0
'                     ---------------------------------------------
LOCATE 16, 29: PRINT "Type in  the name of  the file you  want load";
LOCATE 17, 29: PRINT "and press Enter.  You may specify  a pathname";
LOCATE 18, 29: PRINT "prefix if you desire.  Press ESCape to  abort";
LOCATE 19, 29: PRINT "loading a font."; STRING$(30, 32);
LOCATE 20, 29: PRINT STRING$(45, 32);
LOCATE 21, 29: PRINT STRING$(45, 32);

LOCATE 24, 2
COLOR 7, 0
Filename$ = UCASE$(Filename$)
OldName$ = Filename$
IF OldName$ = "" OR Filename$ = "" THEN
  LOCATE 24, 2: PRINT STRING$(78, 32);
END IF

DO
LOCATE 24, 2
DO                              'edit until Enter or Esc
   Editor Filename$, 2, 79, KeyCode
LOOP UNTIL KeyCode = 13 OR KeyCode = 27
IF KeyCode = 27 THEN
   IF OldName$ = "" OR Filename$ = "" THEN
      LOCATE 24, 2: PRINT STRING$(79, 32);
   ELSE
      Filename$ = OldName$: LOCATE 24, 2: PRINT Filename$
   END IF
   EXIT DO
END IF

   SELECT CASE Filename$
     CASE IS = "": EXIT DO
     CASE ELSE
         SELECT CASE FontGridHeight
         CASE IS = 7: CGAtempbuff$ = SPACE$(2048)
         CASE IS = 13: EGAtempbuff$ = SPACE$(3584)
         CASE IS = 15: VGAtempbuff$ = SPACE$(4096)
         END SELECT
         ErrorStatus = FALSE
         ON ERROR GOTO ErrHandle
         OPEN Filename$ FOR BINARY AS #1
          
           IF LOF(1) = 0 THEN
              CLOSE
              LOCATE 1, 1: PRINT UCASE$(Filename$); " does not exist.";
              Delay 1
              KILL Filename$
              GOSUB ClearStuff
              EXIT DO
           END IF
          
           IF FontGridHeight = 7 AND LOF(1) <> 2048 THEN
              LOCATE 1, 1: PRINT "This isn't an CGA font file !";
              GOSUB ClearStuff
              EXIT DO
           END IF

           IF FontGridHeight = 13 AND LOF(1) <> 3584 THEN
              LOCATE 1, 1: PRINT "This isn't an EGA font file !";
              GOSUB ClearStuff
              EXIT DO
           END IF
          
           IF FontGridHeight = 15 AND LOF(1) <> 4096 THEN
              LOCATE 1, 1: PRINT "This isn't a VGA font file !";
              GOSUB ClearStuff
              EXIT DO
           END IF

           SELECT CASE FontGridHeight
           CASE IS = 7: GET #1, , CGAtempbuff$
           CASE IS = 13: GET #1, , EGAtempbuff$
           CASE IS = 15: GET #1, , VGAtempbuff$
           END SELECT
         CLOSE
         
         LOCATE , , 0
         COLOR 7, 0: LOCATE 24, 2: PRINT UCASE$(Filename$);
        
         IF ErrorStatus = FALSE THEN
            LOCATE 1, 1: PRINT UCASE$(Filename$); " Loaded!";
            Delay 2
         END IF
          
           SELECT CASE FontGridHeight
             CASE IS = 7
              FOR X = 0 TO 255: CGAChar$(X) = "": NEXT X
              StkOPT& = FRE(-2): StrngOPT& = FRE("")
              FontSeg = VARSEG(CGAtempbuff$)
              FontOffset = SADD(CGAtempbuff$)
              FOR SoftFont = 1 TO 2048 STEP 8  'Split Font in to easy to use chunks
                  CGAChar$((SoftFont - 1) \ 8) = MID$(CGAtempbuff$, SoftFont, 8)
              NEXT SoftFont
              RomFont = FALSE
              EXIT DO
             CASE IS = 13
              FOR X = 0 TO 255: EGAChar$(X) = "": NEXT X
              StkOPT& = FRE(-2): StrngOPT& = FRE("")
              FontSeg = VARSEG(EGAtempbuff$)
              FontOffset = SADD(EGAtempbuff$)
              FOR SoftFont = 1 TO 3584 STEP 14 'Split Font in to easy to use chunks
                  EGAChar$((SoftFont - 1) \ 14) = MID$(EGAtempbuff$, SoftFont, 14)
              NEXT SoftFont
              'PutFontIntoString 0
              RomFont = FALSE
              EXIT DO
             CASE IS = 15
              FOR X = 0 TO 255: VGAChar$(X) = "": NEXT X
              StkOPT& = FRE(-2): StrngOPT& = FRE("")
              FontSeg = VARSEG(VGAtempbuff$)
              FontOffset = SADD(VGAtempbuff$)
              FOR SoftFont = 1 TO 4096 STEP 16 'Split Font in to easy to use chunks
                  VGAChar$((SoftFont - 1) \ 16) = MID$(VGAtempbuff$, SoftFont, 16)
              NEXT SoftFont
              'PutFontIntoString 1
              RomFont = FALSE
              EXIT DO
           END SELECT
   END SELECT
LOOP
CLOSE
LOCATE , , 0
LOCATE 1, 1: PRINT STRING$(80, 32);
SELECT CASE FontGridHeight
CASE IS = 7: CGAtempbuff$ = ""
CASE IS = 13: EGAtempbuff$ = ""
CASE IS = 15: VGAtempbuff$ = ""
END SELECT
StkOPT& = FRE(-2): StrngOPT& = FRE("")
EXIT SUB

ClearStuff:
Delay 2
Filename$ = "": OldName$ = Filename$
COLOR 7, 0: LOCATE 24, 2: PRINT STRING$(78, 32);
RETURN
END SUB

SUB LoadFontCharacter (BeginChar, EndChar, Font$)
'BX tells DOS to store 16 lines per char and font bank 0
SELECT CASE FontGridHeight
CASE IS = 7: Registers.BX = &H800
CASE IS = 13: Registers.BX = &HE00
CASE IS = 15: Registers.BX = &H1000
END SELECT
HowManyChars = EndChar - BeginChar 'Find out how many characters are going to be changed
'PRINT HowManyChars: SLEEP
Registers.AX = &H1100        'AX tells call DOS set font routine
Registers.CX = HowManyChars  'CX tells DOS to change 1 or more chracters character
Registers.DX = BeginChar     'DX tells DOS which char to start from
Registers.ES = VARSEG(Font$) ' ES tells DOS where the segment is
Registers.BP = SADD(Font$)   ' BP tells DOS where the address is
CALL INTERRUPTX(&H10, Registers, Registers) ' call int 10 and make changes
END SUB

FUNCTION Monitor% (VSSegment)
DEF SEG = 0              'first see if it's color or mono
VSSegment = &HB800         'assume color

IF PEEK(&H463) = &HB4 THEN

  VSSegment = &HB000       'assign the monochrome segment
  Status = INP(&H3BA)    'get the current video status
  FOR X = 1 TO 30000     'test for a Hercules 30000 times
    IF INP(&H3BA) <> Status THEN
      Monitor% = 2       'the port changed, it's a Herc
      EXIT FUNCTION      'all done
    END IF
  NEXT
  Monitor% = 1           'it's a plain monochrome

ELSE                     'it's some sort of color monitor

  Registers.AX = &H1A00     'first test for VGA
  CALL INTERRUPTX(&H10, Registers, Registers)
  IF (Registers.AX AND &HFF) = &H1A THEN
    Monitor% = 5         'it's a VGA
    EXIT FUNCTION        'all done
  END IF

  Registers.AX = &H1200     'now test for EGA
  Registers.BX = &H10
  CALL INTERRUPTX(&H10, Registers, Registers)
  IF (Registers.BX AND &HFF) = &H10 THEN
    Monitor% = 3         'if BL is still &H10 it's a CGA
  ELSE
    Monitor% = 4         'otherwise it's an EGA
  END IF
END IF
DEF SEG
END FUNCTION

SUB ParseCmdLine (cmd$, Params$(), Found%)
'This parsing sub does NOT mistake filenames like "F-14G.ZIP" as
'containing a switch. That's why it looks so big.
  Found% = FALSE: Sep$ = "-/": Temp$ = LTRIM$(RTRIM$(cmd$)): InParam% = FALSE
  FOR p% = 1 TO LEN(Temp$)
    C$ = MID$(Temp$, p%, 1)
    IF InParam% = TRUE THEN 'Inside of a switch?
      IF INSTR(Sep$, C$) THEN 'Found another switch?
        'Terminate current switch, then start parsing the next one.
        GOSUB MakeParam: MID$(Temp$, p%, 1) = LEFT$(Sep$, 1)
        ParamStart% = p%
      ELSEIF ASC(C$) = 32 OR ASC(C$) = 9 THEN
        GOSUB MakeParam: InParam% = FALSE 'Terminate current switch.
      END IF
    ELSEIF InParam% = -2 THEN 'Inside of a parameter?
      IF ASC(C$) = 32 OR ASC(C$) = 9 THEN 'Terminate parameter with
        GOSUB MakeParam: InParam% = FALSE     'space or TAB.
      END IF
    ELSE
      IF INSTR(Sep$, C$) THEN 'Found start of a switch?
        'Make sure all switches start with "-".
        MID$(Temp$, p%, 1) = LEFT$(Sep$, 1): InParam% = TRUE
        ParamStart% = p%
      ELSEIF ASC(C$) <> 32 AND ASC(C$) <> 9 THEN 'If char isn't a
        InParam% = -2: ParamStart% = p% 'space or TAB it's a parameter.
      END IF
    END IF
  NEXT
 IF InParam% THEN GOSUB MakeParam
  EXIT SUB
MakeParam:
  Found% = Found% + 1
  Params$(Found%) = MID$(Temp$, ParamStart%, p% - ParamStart%)
  IF Found% = UBOUND(Params$) THEN EXIT SUB
RETURN
END SUB

SUB PlotChar (CharNum) 'plots character in Editor Box
ON ERROR GOTO ErrHandle
FOR MN = 0 TO FontGridHeight
SELECT CASE FontGridHeight
CASE IS = 7: PatternNum = ASC(MID$(CGAChar$(CharNum), MN + 1, 1))
CASE IS = 13: PatternNum = ASC(MID$(EGAChar$(CharNum), MN + 1, 1))
CASE IS = 15: PatternNum = ASC(MID$(VGAChar$(CharNum), MN + 1, 1))
END SELECT

FOR X = 1 TO 8
 IF MID$(BinPat$(PatternNum), X, 1) = "1" THEN
    BP$ = BP$ + CHR$(219) + CHR$(219)
 ELSE
    BP$ = BP$ + CHR$(177) + CHR$(177)
 END IF
NEXT X
LOCATE MN + 5, 6: PRINT BP$; : BP$ = ""
NEXT MN
END SUB

SUB PrintAt (Strg$, row, Col, Fg, Bg)
    'This is for 80 column Screens
    IF row < 1 OR Col > 80 THEN
       PrintAt "Illegal Function Call", 1, 1, 7, 0: EXIT SUB
    END IF
    Attr = Fg + Bg * 16
    DEF SEG = &HB800   ' B000 for monochrome systems
    Offset = (row - 1) * 160 + (Col - 1) * 2
    FOR I = 1 TO LEN(Strg$)
        POKE Offset, ASC(MID$(Strg$, I, 1)): Offset = Offset + 1
        POKE Offset, Attr: Offset = Offset + 1
    NEXT
    DEF SEG
'    IF Row = 25 AND Col = 80 THEN Scroll 1, 1, 25, 80, 1
END SUB

SUB PutFontIntoString (FoNTYPE)
SELECT CASE FoNTYPE
   CASE IS = 0 'Ega - Capture Main font for Complete Restoration at exit (optional).
   FontEnd = FontOffset + 3584: DEF SEG = FontSeg
   FOR BiosCopy = FontOffset TO FontEnd
   Byte = PEEK(BiosCopy): EgaFont$ = EgaFont$ + CHR$(Byte): LOCATE 2, 13: PRINT STRING$(LEN(EgaFont$) \ 512, 254);
   NEXT BiosCopy
   FOR OriginFont = 1 TO 3584 STEP 14 'Split Font in to easy to use chunks
       EGAChar$((OriginFont - 1) \ 14) = MID$(EgaFont$, OriginFont, 14)
   NEXT OriginFont
   CASE IS = 1 'Vga - Capture Main font for Complete Restoration at exit (optional).
   FontEnd = FontOffset + 4096: DEF SEG = FontSeg
   FOR BiosCopy = FontOffset TO FontEnd
   Byte = PEEK(BiosCopy): VgaFont$ = VgaFont$ + CHR$(Byte): LOCATE 2, 13: PRINT STRING$(LEN(VgaFont$) \ 512, 254);
   NEXT BiosCopy
   FOR OriginFont = 1 TO 4096 STEP 16 'Split Font in to easy to use chunks
       VGAChar$((OriginFont - 1) \ 16) = MID$(VgaFont$, OriginFont, 16)
   NEXT OriginFont
   CASE IS = 2 'Cga - Capture Main font for Editing only !
     '8x8 CGA Font PART 1
      Registers.AX = &H1130
      Registers.BX = &H300
      CALL INTERRUPTX(&H10, Registers, Registers)
      FontSeg = Registers.ES: FontOffset = Registers.BP
      FontEnd = FontOffset + 1023: DEF SEG = FontSeg
      FOR BiosCopy = FontOffset TO FontEnd
      Byte = PEEK(BiosCopy): CgaFont1$ = CgaFont1$ + CHR$(Byte): LOCATE 2, 13: PRINT STRING$(LEN(CgaFont1$) \ 512, 254);
      NEXT BiosCopy
      DEF SEG
     '8x8 CGA Font PART 2
      Registers.AX = &H1130
      Registers.BX = &H400
      CALL INTERRUPTX(&H10, Registers, Registers)
      FontSeg = Registers.ES: FontOffset = Registers.BP
      FontEnd = FontOffset + 1023: DEF SEG = FontSeg
      FOR BiosCopy = FontOffset TO FontEnd
      Byte = PEEK(BiosCopy): CgaFont2$ = CgaFont2$ + CHR$(Byte): LOCATE 2, 15: PRINT STRING$(LEN(CgaFont2$) \ 512, 254);
      NEXT BiosCopy
      DEF SEG
      CgaFont$ = CgaFont1$ + CgaFont2$
      CgaFont1$ = "": CgaFont2$ = ""
      FOR OriginFont = 1 TO 2048 STEP 8  'Split Font in to easy to use chunks
         CGAChar$((OriginFont - 1) \ 8) = MID$(CgaFont$, OriginFont, 8)
      NEXT OriginFont
CASE ELSE: PRINT "Invalid Romfont bank copy request !": END
END SELECT
DEF SEG
END SUB

FUNCTION Reverse$ (StringVar$)
C$ = MID$(StringVar$, 1, 1)
IF C$ = "" THEN
   ' The first character is null, so return
   ' null--there's no more string left.
   Reverse$ = ""
ELSE
   ' The reverse of a non-null string is the first character
   ' appended to the reverse of the remaining string.
   Reverse$ = Reverse$(MID$(StringVar$, 2)) + C$
END IF
END FUNCTION

SUB SaveFont
COLOR 15, 0: LOCATE 5, 55: PRINT "F3. Save Font"; : COLOR 7, 0
'                     ---------------------------------------------
LOCATE 16, 29: PRINT "Type in  the  name of  the file  you  want to";
LOCATE 17, 29: PRINT "save  the   font  as,  or   press   Enter  to";
LOCATE 18, 29: PRINT "save  it  under  the  existing  name  if any.";
LOCATE 19, 29: PRINT "Press ESCape to abort saving. You may specify";
LOCATE 20, 29: PRINT "a  pathname    prefix    if    you    desire.";
LOCATE 21, 29: PRINT STRING$(45, 32);

LOCATE 24, 2
COLOR 7, 0
Filename$ = UCASE$(Filename$)
OldName$ = Filename$
IF OldName$ = "" OR Filename$ = "" THEN
  LOCATE 24, 2: PRINT STRING$(78, 32);
END IF

DO
LOCATE 24, 2
DO                              'edit until Enter or Esc
   Editor Filename$, 2, 79, KeyCode
LOOP UNTIL KeyCode = 13 OR KeyCode = 27
IF KeyCode = 27 THEN
   IF OldName$ = "" OR Filename$ = "" THEN
      LOCATE 24, 2: PRINT STRING$(78, 32);
   ELSE
      Filename$ = OldName$: LOCATE 24, 2: PRINT Filename$
   END IF
   EXIT DO
END IF

   SELECT CASE Filename$
     CASE IS = "": EXIT DO
     CASE ELSE
         ErrorStatus = FALSE
         ON ERROR GOTO ErrHandle
         OPEN Filename$ FOR OUTPUT AS #1
         FOR SF = 0 TO 255
             SELECT CASE FontGridHeight
              CASE IS = 7: PRINT #1, CGAChar$(SF);
              CASE IS = 13: PRINT #1, EGAChar$(SF);
              CASE IS = 15: PRINT #1, VGAChar$(SF);
             END SELECT
             IF ErrorStatus = TRUE THEN EXIT FOR
         NEXT SF
         CLOSE
         LOCATE , , 0
         LOCATE 24, 2: PRINT UCASE$(Filename$);
       
         IF ErrorStatus = FALSE THEN
            LOCATE 1, 1: PRINT UCASE$(Filename$); " Saved!";
            Delay 2
         ELSE
            LOCATE 1, 1: PRINT UCASE$(Filename$); " NOT Saved!";
            Filename$ = "": OldName$ = Filename$
            Delay 2
            LOCATE 24, 2: PRINT STRING$(78, 32);
         END IF
         EXIT DO
   END SELECT
LOOP
LOCATE , , 0
LOCATE 1, 1: PRINT STRING$(80, 32);
END SUB

